/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

require('./css/IconButton.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IconButton = function (_React$PureComponent) {
    _inherits(IconButton, _React$PureComponent);

    function IconButton(props) {
        _classCallCheck(this, IconButton);

        return _possibleConstructorReturn(this, (IconButton.__proto__ || Object.getPrototypeOf(IconButton)).call(this, props));
    }

    _createClass(IconButton, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            this.dom.addEventListener('mousedown', function (e) {
                e.preventDefault();e.stopPropagation();
            }, false);
            this.dom.addEventListener('click', function (e) {
                if (typeof _this2.props.onClick === 'function') {
                    _this2.props.onClick(e);
                }
            }, false);
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'ck-icon-button';
            var iconType = void 0;
            switch (this.props.iconType) {
                case 'regular':
                    iconType = 'far';
                    break;
                case 'light':
                    iconType = 'fal';
                    break;
                case 'brands':
                    iconType = 'fab';
                    break;
                default:
                    iconType = 'fas';
            }

            base = (0, _bind2.default)(base, iconType, 'fa-' + this.props.icon);

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'getStyles',
        value: function getStyles() {
            var base = {};
            if (this.props.color) {
                base.color = this.props.color;
            }
            return base;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            return _react2.default.createElement('span', { ref: function ref(c) {
                    return _this3.dom = c;
                }, className: this.getClasses(), style: this.getStyles() });
        }
    }]);

    return IconButton;
}(_react2.default.PureComponent);

IconButton.propTypes = {
    iconType: _propTypes2.default.oneOf(['solid', 'regular', 'light', 'brands']),
    icon: _propTypes2.default.string,
    color: _propTypes2.default.string,
    onClick: _propTypes2.default.func
};

IconButton.defaultProps = {};

exports.default = IconButton;
//# sourceMappingURL=IconButton.js.map
