/* @clake/react-bootstrap4-window v0.1.8 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-04-26T19:44:48+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

require('./css/TopMenu.less');

var _reactBootstrap = require('@clake/react-bootstrap4');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TopMenu = function (_React$PureComponent) {
    _inherits(TopMenu, _React$PureComponent);

    function TopMenu(props) {
        _classCallCheck(this, TopMenu);

        var _this = _possibleConstructorReturn(this, (TopMenu.__proto__ || Object.getPrototypeOf(TopMenu)).call(this, props));

        _this.clickHandler = function (key) {
            if (typeof _this.props.onClick === 'function') {
                _this.props.onClick(key);
            }
        };

        _this.cur_active = null;
        _this.is_active = false;
        return _this;
    }

    _createClass(TopMenu, [{
        key: 'componentDidMount',
        value: function componentDidMount() {}
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'ck-top-menu d-flex border-bottom shadow';

            if (this.props.top) {
                base = (0, _bind2.default)(base, 'ck-top-menu-top');
            }

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                { className: this.getClasses() },
                _react2.default.Children.map(this.props.children, function (item) {
                    item.props.parent = _this2;
                    return _react2.default.cloneElement(item, item.props);
                })
            );
        }
    }]);

    return TopMenu;
}(_react2.default.PureComponent);

TopMenu.propTypes = {
    top: _propTypes2.default.bool,
    onClick: _propTypes2.default.func
};

TopMenu.defaultProps = {};

var Item = function (_React$PureComponent2) {
    _inherits(Item, _React$PureComponent2);

    function Item(props) {
        _classCallCheck(this, Item);

        var _this3 = _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).call(this, props));

        _this3.clickHandler = function (e) {
            if (typeof _this3.props.onClick === 'function') {
                _this3.props.onClick(_this3.props.name);
            } else {
                if (_this3.menu) {
                    _this3.parent.is_active = true;
                    _this3.parent.cur_active = _this3.dom;
                    _this3.parent.cur_menu = _this3.menu;
                    _this3.dom.classList.add('active');
                    _this3.menu.show({
                        evt: e,
                        type: 'dom-bottom',
                        data: '',
                        close: _this3.closeHandler
                    });
                }
            }
        };

        _this3.changeActive = function (e) {
            if (_this3.parent.is_active) {
                if (_this3.parent.cur_active === _this3.dom) return;
                if (_this3.parent.cur_active) {
                    _this3.parent.cur_active.classList.remove('active');
                    _this3.parent.cur_menu.hide();
                }
                _this3.clickHandler(e);
            }
        };

        _this3.closeHandler = function (e) {
            // console.log(e);
            // // console.log('close');
            // console.log(this.props.text);
            if (e) {
                if (_this3.parent.cur_active) {
                    _this3.parent.cur_active.classList.remove('active');
                    _this3.parent.is_active = false;
                    _this3.parent.cur_menu = null;
                }
            }
        };

        _this3.parent = _this3.props.parent || null;
        _this3.domId = 'topmenu-item-' + _reactBootstrap.Common.RandomString(16);
        return _this3;
    }

    _createClass(Item, [{
        key: 'componentDidMount',
        value: function componentDidMount() {}
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'ck-top-menu-item';

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            return _react2.default.createElement(
                'div',
                { ref: function ref(c) {
                        return _this4.dom = c;
                    }, id: this.domId, className: this.getClasses(),
                    onMouseOver: this.changeActive,
                    onClick: this.clickHandler },
                this.props.text,
                _react2.default.Children.map(this.props.children, function (item) {
                    item.props.parent = _this4;
                    item.props.ref = function (c) {
                        _this4.menu = c;
                    };
                    return _react2.default.cloneElement(item, item.props);
                    // return item;
                })
            );
        }
    }]);

    return Item;
}(_react2.default.PureComponent);

Item.propTypes = {
    text: _propTypes2.default.string,
    parent: _propTypes2.default.any,
    onClick: _propTypes2.default.func,
    name: _propTypes2.default.string
};

Item.defaultProps = {};

TopMenu.Item = Item;

exports.default = TopMenu;
//# sourceMappingURL=TopMenu.js.map
